LoadAddOn("FuBarPlugin-3.0")

local _G				= getfenv(0)

local pairs				= _G.pairs
local select			= _G.select
local type				= _G.type

local table_insert		= _G.table.insert
local table_remove		= _G.table.remove
local table_sort		= _G.table.sort

local GetGuildRosterInfo	= _G.GetGuildRosterInfo
local GetNumGuildMembers	= _G.GetNumGuildMembers
local GetItemInfo			= _G.GetItemInfo



local PLAYERNAME 		= UnitName("player")
local _, PLAYERCLASS 	= UnitClass("player")
local PLAYERGUID 		= 0


_G.GigaItemAuction = LibStub("AceAddon-3.0"):NewAddon("GigaItemAuction", "AceConsole-3.0", "AceTimer-3.0", "AceComm-3.0", "AceSerializer-3.0", "AceEvent-3.0")

local GigaItemAuction = _G.GigaItemAuction
GigaItemAuction.mainmenuopts = options
GigaItemAuction.revision = tonumber(string.sub("$Revision: 20 $", 12, -3))
GigaItemAuction.revisionNEW = GigaItemAuction.revision
GigaItemAuction.versioncheckraid = 0
GigaItemAuction.versioncheckguild = 0


local L = LibStub("AceLocale-3.0"):GetLocale("GigaItemAuction", false)
local LDB = LibStub("LibDataBroker-1.1", true)
local LDBIcon = LDB and LibStub("LibDBIcon-1.0", true)
local tablet = AceLibrary("Tablet-2.0")

local db

GigaItemAuction.auctionAdminBreak 		= false
GigaItemAuction.auctionStatusSTART 		= false
GigaItemAuction.auctionStatusPAUSE 		= false
GigaItemAuction.auctionStatusSONDERBID 	= false
GigaItemAuction.auctionStatusBIDDING 	= true

local selfBid 				= false
local waitForVersionIncomig = false

local groupList = {}
local guildList = {}
local versionList = {}

---------

local defaults = {
	profile = {
		config = {
			startAddon 			= true,
			showAuctionWindow 	= false,
			showAdminWindow 	= false,
			debugmodus 			= false,
			debugadmin 			= false,
			bidArt 				= "M",
			bidU80 				= false,
			announceAuction 	= false,
			playsound = {
				auctionend 			= true,
				auctionstart 		= true,
				newgebot 			= true,
				backgebot 			= true,
				pause 				= true,
				pausestart 			= true,
				errormsg 			= true,
				longauction 		= true,
			},
			bidStep = {
				step1 				= 5,
				step2 				= 10,
				step3 				= 25,
				step4 				= 50,
			},
		},
		position = {
			x 					= 0,
			y 					= 0,
			relpoint 			= "CENTER",
			point 				= "CENTER",
		},
		nowAuction = {
			itemID 				= 0,
			itemLink 			= "",
			auctionAuthor 		= "",
			channel 			= "",
			last = {
				BidName 			= "",
				BidPoint 			= 0,
				BidTime 			= 0,
				BidArt 				= "X",
				BidU80 				= false
			},
			cache = {
	--~ 		{BidName = "string", BidPoint = "number", BidTime = "number", BidArt = "string", BidU80 = "boolean"}
			},
		},
		auctionCache = {
	--~ 	{BidName = "string", BidItem = "string", BidPoint = "number", BidTime = "number", BidArt = "string", BidU80 = "boolean", BidMethod = "string"}
		},
		filter = {
			class 				= PLAYERCLASS,
			itemType = {
				showAll 			= true,
			},
			itemSubType = {},
			itemEquipLoc = {},
		},
		admin = {
			bidStep = 5,
			bidTime = 30,
			bidUP = 80,
			bidArt = {
				main = true,
				second = true,
				fun = true,
				u80 = true,
				hide = false,
			},
		},
		FuBar = {
			HideMinimapButton 	= false,
			AttachMinimap 		= false,
		},
		MinimapIcon = {
			hide 				= false,
			minimapPos 			= 220,
			radius 				= 80,
		},
	}
}

--~ AddonMessages
GigaItemAuction.amsg = {
	prefix = "GIAAM",
	key = {
		bidpoint 			= "BP",
		endauction 			= "EA",
		breakauction 		= "BA",
		newbidtime 			= "NB",
		auctionlong 		= "AL",
		
		sendauctiondata 	= "SAD",
		getauctiondata 		= "GAD",
		
		sendtruebid 		= "STB",
		sendfalsebid 		= "SFB",
		sendpassbid 		= "SPB",
		
		sendresetauction 	= "SRA",
		sendstartauction 	= "SSA",
		sendpauseauction 	= "SPA",
		sendendauction		= "SEA",
		
		sendbidtime 		= "SBT",
		getbidtime 			= "GBT",
		
		sendtimecheck 		= "STC",
		gettimecheck 		= "GTC",
		
		sendversioncheck 	= "SVC",
		getversioncheck 	= "GVC",
		revision 			= "V",
	}
}
----------
GigaItemAuction.itemEquipLoc = {
		["INVTYPE_2HWEAPON"] 		= L["EquipLoc Two Hand"], -- Two-Hand
		["INVTYPE_BODY"] 			= L["EquipLoc Shirt"], -- Shirt
		["INVTYPE_CHEST"] 			= L["EquipLoc Chest"], -- Chest
		["INVTYPE_CLOAK"] 			= L["EquipLoc Back"], -- Back
		["INVTYPE_FEET"] 			= L["EquipLoc Feet"], -- Feet
		["INVTYPE_FINGER"] 			= L["EquipLoc Finger"], -- Finger
		["INVTYPE_FINGER_OTHER"] 	= L["EquipLoc Finger"], -- Finger_other
		["INVTYPE_HAND"] 			= L["EquipLoc Hands"], -- Hands
		["INVTYPE_HEAD"] 			= L["EquipLoc Head"], -- Head
		["INVTYPE_HOLDABLE"] 		= L["EquipLoc Off Hand"], -- Held In Off-hand
		["INVTYPE_LEGS"] 			= L["EquipLoc Legs"], -- Legs
		["INVTYPE_NECK"] 			= L["EquipLoc Neck"], -- Neck
		["INVTYPE_RANGED"] 			= L["EquipLoc Ranged"], -- Ranged
		["INVTYPE_RANGEDRIGHT"] 	= L["EquipLoc Ranged"], -- Ranged
		["INVTYPE_RELIC"] 			= L["EquipLoc Relic"], -- Relic
		["INVTYPE_ROBE"] 			= L["EquipLoc Chest"], -- Chest
		["INVTYPE_SHIELD"] 			= L["EquipLoc Shield"], -- Off Hand	Shield
		["INVTYPE_SHOULDER"] 		= L["EquipLoc Shoulder"], -- Shoulder
		["INVTYPE_TABARD"] 			= L["EquipLoc Tabard"], -- Tabard
		["INVTYPE_TRINKET"] 		= L["EquipLoc Trinket"], -- Trinket
		["INVTYPE_TRINKET_OTHER"] 	= L["EquipLoc Trinket"], -- Trinket_other
		["INVTYPE_WAIST"] 			= L["EquipLoc Waist"], -- Waist
		["INVTYPE_WEAPON"] 			= L["EquipLoc One Hand"], -- One-Hand
		["INVTYPE_WEAPON_OTHER"] 	= L["EquipLoc One Hand"], -- One-Hand_other
		["INVTYPE_WEAPONMAINHAND"] 	= L["EquipLoc Main Hand"], -- Main Hand
		["INVTYPE_WEAPONOFFHAND"] 	= L["EquipLoc Off Hand"], -- Off Hand
		["INVTYPE_WRIST"] 			= L["EquipLoc Wrist"], -- Wrist
		["INVTYPE_WAND"] 			= L["EquipLoc Wand"], -- Wand
		["INVTYPE_GUN"] 			= L["EquipLoc Gun"], -- Gun
		["INVTYPE_GUNPROJECTILE"] 	= L["EquipLoc Projectile"], -- Projectile
		["INVTYPE_BOWPROJECTILE"] 	= L["EquipLoc Projectile"], -- Projectile
		["INVTYPE_CROSSBOW"] 		= L["EquipLoc Crossbow"], -- Crossbow
		["INVTYPE_THROWN"] 			= L["EquipLoc Thrown"], -- Thrown
}
----------
GigaItemAuction.BidPriority = {
	["M"] 	= 1,
	["MU"] 	= 2,
	["S"] 	= 3,
	["SU"]	= 4,
	["F"]	= 5,
	["FU"]	= 6,
	["X"]	= 7,
}
----------
GigaItemAuction.colors = {
	neutral 	= {	0.5,	0.5,	0.5,	1	},
	red			= {	1,		0,		0,		1	},
	red_dark	= {	0.55,	0.08,	0.08,	1	},
	green		= {	0,		1,		0,		1	},
	blue		= {	0.3,	0.3,	1,		1	},
	blue_dark	= {	0.2,	0.26,	0.33,	1	},
	yellow		= {	1,		1,		0,		1	},
	white		= {	1,		1,		1,		1	},
	black		= {	0,		0,		0,		1	},
	black_trans	= {	0,		0,		0,		0.8	},
	blue_trans	= {	0,		0,		0.4,	0.9	},
	red_trans	= {	0.4,	0,		0,		0.9	},
}
----------
GigaItemAuction.ScheduleTimers = {
	StopAuctionButtons = false,
	StopAdminAuction = false,
	SetButtonEnable = false,
	VersionCheckEnd = false,
}

---------------------------------------
-- local functione 
---------------------------------------
local function getGameTimeAsUnix()
	return time()
end

local function getCurrentDate(timestamp, short)
	local dt = date("*t", timestamp)
	if short then
		return string.format("%02d:%02d:%02d", dt.hour, dt.min, dt.sec)
	else
		return string.format("%02d/%02d/%d - %02d:%02d:%02d", dt.day , dt.month, dt.year, dt.hour, dt.min, dt.sec)
	end
end

local function getCurrentMiniDate(timestamp)
	local dt = date("*t", timestamp)
	return string.format("%02d:%02d:%02d - %02d/%02d", dt.hour, dt.min, dt.sec, dt.day , dt.month)
end
----------

---------------------------------------
--~ Addon Initialiaze
---------------------------------------
function GigaItemAuction:DataBaseOnInitialize(database)
	db 			= database
	
	--initialize database
	self:SYNCOnInitialize()
	self:OPTIONSOnInitialize()
	self:FRAMEOnInitialize()
	self:ADMINOnInitialize()
	self:FILTEROnInitialize()
end

function GigaItemAuction:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("GigaItemAuctionDB", defaults)
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileReset", "OnProfileChanged")
	
	self:DataBaseOnInitialize(self.db.profile)
end
function GigaItemAuction:OnProfileChanged(event, database, newProfileKey)
	self:DataBaseOnInitialize(database)
end
function GigaItemAuction:OnEnable(called)
	self:Print(L["Enable."])
	
	GuildRoster()	
	
	PLAYERGUID 	= tonumber(UnitGUID("player"), 16)
	
	self:SyncBidArt()
	
	--create frames
	self:CreateAUCTIONFrame()
	self:CreateADMINFrame()
	
	--hide frames
	self:HideAUCTIONFrame()	
	self:HideADMINFrame()
	
	self:SyncButtonsWithDatabase()
	
	--config initialize and setup
	self:SetupOptions()
    
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "GIAFuBarOnInitialize")
	
	if db.config.debugadmin then
		self:RegisterEvent("CHAT_MSG_WHISPER")
	end
	
	self:RegisterEvent("CHAT_MSG_RAID")
	self:RegisterEvent("CHAT_MSG_RAID_LEADER","CHAT_MSG_RAID")
	self:RegisterEvent("CHAT_MSG_GUILD")
	self:RegisterEvent("RAID_ROSTER_UPDATE", "RaidGuildVersionSend")
--~	self:RegisterEvent("GUILD_ROSTER_UPDATE", "RaidGuildVersionSend")
	
	db.config.startAddon = true
	
	self:ClearNowAuction()
	self:GIAFuBarChangeState()
	
	if UnitInRaid("player") or IsInGuild() then 
		self:SendAddonMSG(self:Serialize(self.amsg.key.revision, self.revision), "GUILD")
	end
end

function GigaItemAuction:OnDisable()
	self:Print(L["Disable."])
	self:GIAFuBarChangeState()
	self:HideAUCTIONFrame()
	self:HideADMINFrame()
end
---










---------------------------------------
--~ EventEmpfang
---------------------------------------
function GigaItemAuction:CHAT_MSG_RAID(event, text, author)
	if not db.config.startAddon then return end
		
	if string.sub(text, -2) == "5#" then
		
		if db.config.debugmodus then
			self:Print("|cff5555ffDEBUG:|r INCOMING - New Auction. Channel: RAID")
		end
		
--~ 		Itemdata defenieren
		local itemName, itemLink = GetItemInfo(string.sub(text, 1, -2))
		
		if itemName and itemLink then
			self:StartAuction(text, author, "RAID")
		end
	end
	
end

function GigaItemAuction:CHAT_MSG_GUILD(event, text, author)
	if not db.config.startAddon then return end
	
	if string.sub(text, -2) == "5#" then
		
		if db.config.debugmodus then
			self:Print("|cff5555ffDEBUG:|r INCOMING - New Auction. Channel: GUILD")
		end
		
--~ 		Itemdata defenieren
		local itemName, itemLink = GetItemInfo(string.sub(text, 1, -2))
		
		if itemName and itemLink then
			self:StartAuction(text, author, "GUILD")
		end
	end
	
end

function GigaItemAuction:CHAT_MSG_WHISPER(event, text, author)
	if not db.config.startAddon then return end
	
	if string.sub(text, -2) == "5#" and db.config.debugadmin then
		
		self:Print("|cff5555ffDEBUG:|r INCOMING - New Auction. Channel: WHISPER")
		
--~ 		Itemdata defenieren
		local itemName, itemLink = GetItemInfo(string.sub(text, 1, -2))
		
		if itemName and itemLink then
			self:StartAuction(text, author, "WHISPER")
		end
		
	end
end

function GigaItemAuction:RaidGuildVersionSend()
	
	if UnitInRaid("player") then
		local NumRaidMember = GetNumRaidMembers()
		if self.versioncheckraid < NumRaidMember then
			self:SendAddonMSG(self:Serialize(self.amsg.key.revision, self.revision), "RAID")
	--~ 		send revision for old revision player if (my.revision > revision.19)
			SendAddonMessage(self.amsg.prefix, self.amsg.key.revision.." 99999", "RAID")
		end
		self.versioncheckraid = NumRaidMember
	end
	if IsInGuild() then
		local NumGuildMembers = GetNumGuildMembers(false)
		if self.versioncheckguild < NumGuildMembers then
			self:SendAddonMSG(self:Serialize(self.amsg.key.revision, self.revision), "GUILD")
	--~ 		send revision for old revision player if (my.revision > revision.19)
			SendAddonMessage(self.amsg.prefix, self.amsg.key.revision.." 99999", "GUILD")
		end
		self.versioncheckguild = NumGuildMembers
	end
	
end



---------------------------------------
--~ Auctionen
---------------------------------------
function GigaItemAuction:StartAuction(text, author, channel)
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin

--~ 	Check, ob der Sender die Berechtigung hat eine Action zu starten
	if not self:CheckPriority(author) then 
		if PLAYERNAME == author then
			self:Print(L["secutity1"])
		end
		return 
	end
	
	if channel == "GUILD" then
		self:SendAddonMSG(self:Serialize(self.amsg.key.revision, self.revision), "GUILD")
	end
	
	self.auctionStatusSTART = true
	
	self:ClearNowAuction()
	
--~ 	Itemdata defenieren
	local itemName, itemLink, itemRarity, _, _, itemType, itemSubType, _, itemEquipLoc, itemTexture = GetItemInfo(string.sub(text, 1, -2))
	local itemID = select(3, itemLink:find("item:(%d+):"))
	itemID = tonumber(itemID:trim())
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
		
	if dbc.debugadmin then
		self:Print("|cff5555ffDEBUG:|r ITEM - "..
		"itemName:"..(itemName or "nil")..", itemRarity:"..(itemRarity or "-")..", itemType:"..(itemType or "-")..", itemSubType:"..(itemSubType or "-")..", itemEquipLoc:"..(itemEquipLoc or "-"))
	end
	
	self.auctionStatusBIDDING = self:ItemFilterCheck(itemType, itemSubType, itemEquipLoc)
	
	if author == PLAYERNAME then
		self.auctionStatusBIDDING = true
	end
	
	dbn.itemID = itemID
	dbn.itemLink = itemLink
	dbn.auctionAuthor = author
	dbn.channel = channel
	dbn.last.BidName = ""
	dbn.last.BidPoint = tonumber(0)
	dbn.last.BidArt = "X"
	dbn.last.BidU80 = false

	self:SendAddonMSG(self:Serialize(self.amsg.key.getbidtime, 1), "WHISPER", author)
	
	if dbc.debugadmin then
		self:Print("|cff5555ffDEBUG:|r |cffffff55SEND|r - Auctioneer admin data to "..dbn.auctionAuthor)
	end
	
	self:StartAdmin()

	self:StopStatusbar()
	
	self.AUCTIONFrame.itemIcon:SetNormalTexture(itemTexture)
	self.AUCTIONFrame.itemName:SetText(itemLink)
	self.AUCTIONFrame.itemName2:SetText(((itemEquipLoc and self.itemEquipLoc[itemEquipLoc]) and (self.itemEquipLoc[itemEquipLoc].." ") or (itemType and (itemType.." ") or ""))..(itemSubType and ("["..itemSubType.."]") or (itemType or "")))
		
	self:SetAuctionStats()	
	self:SetAuctionColors()
		
	self:SetButtonEnable()
	self:SetBreakButtonDisable()
	
	if self.auctionStatusBIDDING then
		self:StartStatusBar()
		self:ShowAUCTIONFrame()
		
		self:GIAFuBarChangeState()
		
		if dbc.playsound.auctionstart then
			PlaySound("igPlayerInvite") 
		end
		
		self:UpdateBidList()
	end	
	
	if author == PLAYERNAME then
		self:GIATimerStart("StopAdminAuction","StopAdminAuction", dba.bidTime + 1)
	end
	self:GIATimerStart("StopAuctionButtons","SetAllButtonDisable", dba.bidTime)
end

function GigaItemAuction:NewBidAuction(value, author)
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	local _, _, bidPoint, itemID, bidArt, bidU80, bidGUID, bidTime, sendTime = self:Deserialize(value)
		
	self:GIATimerStop("SetButtonEnable")
	
	if tonumber(sendTime) < dbn.last.BidTime then return end
	
	if dba.bidTime ~= tonumber(bidTime) then
		dba.bidTime = tonumber(bidTime)
	end
	
	if author == PLAYERNAME then 
		self.auctionStatusBIDDING = true
	
--~ 	aktionsende stoppen und neu setzen
		self:GIATimerStart("StopAdminAuction","StopAdminAuction", dba.bidTime + 1)
	end
	self:GIATimerStart("StopAuctionButtons","SetAllButtonDisable", dba.bidTime)
	
	if self.auctionStatusBIDDING then	
		self:AbfrageObJetztAktion(author)		
		
	--~ 	gebotbuttons kurz deaktivieren
		self:SetButtonDisable()
		if bidGUID ~= PLAYERGUID then
			self:GIATimerStart("SetButtonEnable","SetButtonEnable", 1)
		end
	end
	
--~ 	aktuellen gebot eintragen
	dbn.last.BidPoint = tonumber(bidPoint)
	dbn.last.BidName = bidGUID
	dbn.last.BidTime = tonumber(sendTime)
	dbn.last.BidArt = bidArt
	dbn.last.BidU80 = bidU80
	
	if self.auctionStatusBIDDING and dbc.playsound.newgebot and author ~= PLAYERNAME and self.AUCTIONFrame:IsVisible() then
		PlaySound("AuctionWindowOpen")
	end
	
	self:SetAuctionStats()
	self:SetAuctionColors()
	
	if self.auctionStatusBIDDING then
		if dbn.last.BidName == PLAYERGUID then
			selfBid = true
			self:ShowAUCTIONFrame()
		end
		
		self:StopStatusbar()
		if self.AUCTIONFrame:IsVisible() then
			self:StartStatusBar()
		end
		
		if dbn.last.BidName == PLAYERGUID then
			self:SetButtonDisable()
			self:SetBreakButtonEnable()
		else
			self:SetBreakButtonDisable()
		end
		
		
		if author == PLAYERNAME and not selfBid then
			self:UpdateBidList()
		end
	end
end

function GigaItemAuction:FalseBidAuction(errorName, author)
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	
	self:Print(L[errorName]:format(author))
	if dbc.playsound.errormsg then
		PlaySound("igQuestFailed")
	end
end

function GigaItemAuction:AbfrageObJetztAktion(author)
	if not self.auctionStatusSTART and not self.auctionStatusSONDERBID then
		if not StaticPopupDialogs["NewBid"] and not self.auctionStatusSONDERBID then
			StaticPopupDialogs["NewBid"] = {
				text = "",
				button1 = "Ja",
				button2 = "Nein",
				timeout = 0,
				whileDead = 1,
				hideOnEscape = 1,
				OnAccept = function()  
					GigaItemAuction.auctionStatusSONDERBID = true
				end,
				OnCancel = function()
					GigaItemAuction.auctionStatusSONDERBID = false
				end,
				OnHide = function()
					GigaItemAuction.auctionStatusSONDERBID = false
				end,
			}
		end
		
		self:SendAddonMSG(self:Serialize(self.amsg.key.getauctiondata, 1), "WHISPER", author)
		
		if not self.auctionStatusSONDERBID then			
			StaticPopupDialogs["NewBid"].text = "Es wird gerade ein Item versteigert.\nDoch Sie haben keine Daten dazu.\nWollen Sie auch mit bieten und die Daten von Admin einholen?"
			StaticPopup_Show("NewBid") 
		end
	end
end
---------------------------------------
--~ INCOMING to Auctioneer
---------------------------------------
function GigaItemAuction:IncomingNewBid(value, author)
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	
	local _, _, bidPoint, itemID, bidArt, bidU80, playerGUID = self:Deserialize(value)
		
	local sendAttbibut 	= nil
	local sendTime 		= getGameTimeAsUnix()
	
	bidPoint 	= tonumber(bidPoint)
	itemID 		= tonumber(itemID)
	bidU80 		= bidU80
	
	if dbc.debugadmin then
		self:Print("|cff5555ffDEBUG:|r INC NEW BID: au: "..author..", pid: "..playerGUID..", bp: "..bidPoint..", iid: "..itemID..", ba: "..bidArt..", b8: "..(bidU80 and "YES" or "NO"))
	end
	
	local priorityArt, priorityCheck, under80Check, pointArt
	local playerBidU80, auctionBidU80 = self.BidPriority[bidArt..(bidU80 and "U" or "")], self.BidPriority[dbn.last.BidArt..(dbn.last.BidU80 and "U" or "")]
	local playerBidPoint, auctionBidPoint = bidPoint, dbn.last.BidPoint
	local stufenArt = {
		["hoeher"] = 3,
		["gleich"] = 2,
		["kleiner"] = 1,
	}
	local stufenPriorityCheck = {
		[self.BidArt.kurz[1]] = dba.bidArt.main,
		[self.BidArt.kurz[2]] = dba.bidArt.second,
		[self.BidArt.kurz[3]] = dba.bidArt.fun,
	}
	
	-- attend define
	if playerBidU80 < auctionBidU80 then
		priorityArt = stufenArt["hoeher"]
	elseif playerBidU80 == auctionBidU80 then
		priorityArt = stufenArt["gleich"]
	elseif playerBidU80 > auctionBidU80 then
		priorityArt = stufenArt["kleiner"]
	end
	
	-- bidpoint define
	if playerBidPoint > auctionBidPoint then
		pointArt = stufenArt["hoeher"]
	elseif playerBidPoint == auctionBidPoint then
		pointArt = stufenArt["gleich"]
	elseif playerBidPoint < auctionBidPoint then
		pointArt = stufenArt["kleiner"]
	end
	
	--priority check	
	if bidU80 then
		if dba.bidArt.u80 then
			under80Check = true
		else
			under80Check = false
		end
	else
		under80Check = true
	end
		
	if stufenPriorityCheck[bidArt] then
		priorityCheck = true
	else
		priorityCheck = false
	end
	
	if 
		self.auctionStatusSTART 
		and under80Check and priorityCheck 
		and PLAYERNAME == dbn.auctionAuthor
		and (
				(priorityArt == stufenArt["gleich"] and pointArt == stufenArt["hoeher"])
				or priorityArt == stufenArt["hoeher"]
			)
		and playerGUID ~= dbn.last.BidName
		and itemID == dbn.itemID 
	then
		
--~		send truebid
		sendAttbibut = self:Serialize(self.amsg.key.sendtruebid, bidPoint, itemID, bidArt, bidU80, playerGUID, dba.bidTime, sendTime)
		self:SendAddonMSG(sendAttbibut)
		
--~ 	verlauf eintragen
		table_insert(dbn.cache, {
				BidMethod 	= "G",
				BidName 	= author,
				BidGUID		= playerGUID,
				BidPoint 	= bidPoint,
				BidTime 	= sendTime, 
				BidArt 		= bidArt,
				BidU80 		= bidU80,
			}
		)
		
		
	elseif priorityArt == stufenArt["gleich"] and pointArt < stufenArt["hoeher"] then
		
		self:SendAddonMSG(self:Serialize(self.amsg.key.sendfalsebid, "error2"), "WHISPER", author)
		
	elseif priorityArt < stufenArt["gleich"] then
		
		self:SendAddonMSG(self:Serialize(self.amsg.key.sendfalsebid, "error1"), "WHISPER", author)
		
	elseif playerGUID == dbn.last.BidName then
		
		self:SendAddonMSG(self:Serialize(self.amsg.key.sendfalsebid, "error3"), "WHISPER", author)
		
	elseif PLAYERNAME ~= dbn.auctionAuthor then
		
		self:SendAddonMSG(self:Serialize(self.amsg.key.sendfalsebid, "error4"), "WHISPER", author)
		
	elseif itemID ~= dbn.itemID then
		
		self:SendAddonMSG(self:Serialize(self.amsg.key.sendfalsebid, "error6"), "WHISPER", author)
		
	elseif not self.auctionStatusSTART then
		
		self:SendAddonMSG(self:Serialize(self.amsg.key.sendfalsebid, "error7"), "WHISPER", author)	
		
	elseif not under80Check or not priorityCheck then
		
		self:SendAddonMSG(self:Serialize(self.amsg.key.sendfalsebid, "error8"), "WHISPER", author)
		self:AdminCurrentAuctionSend(author, "WHISPER")
		
	end
end

function GigaItemAuction:IncomingPassLastBid(value, author)
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	
	local _, _, playerGUID 	= self:Deserialize(value)
	local cache 			= dbn.cache
	local sendAttbibut 		= nil
	local foundLast 		= false
	local editLast 			= false
	
	if playerGUID == dbn.last.BidName then
--~ 		letzen bieter ermitteln
		table_sort(cache,	function(w1,w2)
								if w1.BidTime > w2.BidTime then
									return true
								end
							end)
		
		for i, p in pairs(cache) do
			if p.BidMethod == "G" then
				if editLast then
--~ 					letzen bieter senden
					table_remove(cache,i)
--~ 					letzen bieter senden
					sendAttbibut = self:Serialize(self.amsg.key.sendtruebid, p.BidPoint, dbn.itemID, p.BidArt, p.BidU80, p.BidGUID, dba.bidTime, getGameTimeAsUnix())
					self:SendAddonMSG(sendAttbibut)
					self:SendAddonMSG(self:Serialize(self.amsg.key.sendfalsebid, "hinweis1"))
					foundLast = true
					break
				else
					cache[i].BidMethod = "P"
					editLast = true
				end
			end
		end
		
		if not foundLast then
			self:SendAdminResetAuction()
			selfBid = false
		end
	else
		self:SendAddonMSG(self:Serialize(self.amsg.key.sendfalsebid, "error5"), "WHISPER", author)
	end
end

---------------------------------------
--~ INCOMING to Bidder
---------------------------------------
function GigaItemAuction:IncomingAuctionDATA(value, author)
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin

	local _, _, inc_itemID, inc_auctionAuthor, inc_channel, inc_playedGUID, inc_BidPoint, inc_BidTime, inc_BidArt, inc_BidU80 = self:Deserialize(value)
	
	
--~ 	Itemdata defenieren
	local itemName, itemLink, itemRarity, _, _, itemType, itemSubType, _, itemEquipLoc, itemTexture = GetItemInfo(tonumber(inc_itemID))
	
	self.auctionStatusBIDDING = self:ItemFilterCheck(itemType, itemSubType, itemEquipLoc)
	
	if inc_auctionAuthor == PLAYERNAME then
		self.auctionStatusBIDDING = true
	end
	
	dbn.itemID = tonumber(inc_itemID)
	dbn.itemLink = itemLink
	dbn.auctionAuthor = inc_auctionAuthor
	dbn.channel = inc_channel
	dbn.last.BidName = inc_playedGUID
	dbn.last.BidPoint = tonumber(inc_BidPoint)
	dbn.last.BidArt = inc_BidArt
	dbn.last.BidTime = tonumber(inc_BidTime)
	dbn.last.BidU80 = inc_BidU80
	
	self:SendAddonMSG(self:Serialize(self.amsg.key.getbidtime, 1), "WHISPER", inc_auctionAuthor)
	self:StopStatusbar()
	
	self.AUCTIONFrame.itemIcon:SetNormalTexture(itemTexture)
	self.AUCTIONFrame.itemName:SetText(itemLink)
	self.AUCTIONFrame.itemName2:SetText((itemEquipLoc and self.itemEquipLoc[itemEquipLoc] and (self.itemEquipLoc[itemEquipLoc].." ") or "")..(itemSubType and ("["..itemSubType.."]") or (itemType or "")))
		
	self:SetBreakButtonDisable()
	
	self:SetAuctionStats()	
	self:SetAuctionColors()
	
	if self.auctionStatusSONDERBID and self.auctionStatusBIDDING then
		self:StartAdmin()	
		self:ShowAUCTIONFrame()
	else
		self:HideAUCTIONFrame()
	end
	
	self.auctionStatusSONDERBID = false	
	self.auctionStatusSTART = true
	
	if self.AUCTIONFrame:IsVisible() and self.auctionStatusBIDDING then
		self:StartStatusBar()
	end
	
	self:GIAFuBarChangeState()
	
	self:SetButtonEnable()
	
	if dbc.playsound.auctionstart and self.auctionStatusBIDDING then
		PlaySound("igPlayerInvite") 
	end
	
	self:UpdateBidList()	
	
	if inc_auctionAuthor == PLAYERNAME then
		self:GIATimerStart("StopAdminAuction","StopAdminAuction", dba.bidTime + 1)
	end
	self:GIATimerStart("StopAuctionButtons","SetAllButtonDisable", dba.bidTime)
end

function GigaItemAuction:ResetAuction(author)
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
--~ 	Check, ob der Sender die Berechtigung hat eine Action zu starten
	if not self:CheckPriority(author) then 
		if PLAYERNAME == author then
			self:Print(L["secutity4"])
		end
		return 
	end
	
	for k in pairs(dbn.cache) do
		dbn.cache[k] = nil
	end
	
	dbn.last.BidName = ""
	dbn.last.BidPoint = tonumber(0)
	dbn.last.BidArt = "X"
	dbn.last.BidU80 = false

	self:StopStatusbar()
	
	self:SetBreakButtonDisable()
	
	self:SetAuctionStats()	
	self:SetAuctionColors()
	
	if self.auctionStatusBIDDING then
		self:StartStatusBar()
		self:ShowAUCTIONFrame()
	end
	
	self:SetButtonEnable()
	
	self:UpdateBidList()
		
	self.ADMINFrame.pauseButton:Enable()
	self.ADMINFrame.aLongButton:Enable()
	self.ADMINFrame.startButton:Disable()
	
	self:SetStatusbarText(L["statusbar_text_start"])
	
	if author == PLAYERNAME then
		self:GIATimerStart("StopAdminAuction","StopAdminAuction", dba.bidTime + 1)
	end
	self:GIATimerStart("StopAuctionButtons","SetAllButtonDisable", dba.bidTime)
end


---------------------------------------
--~ Timersteuerung steuerung
---------------------------------------
function GigaItemAuction:GIATimerStart(timerName, funcName, timerTime)
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	
	self:GIATimerStop(timerName)
	self.ScheduleTimers[timerName] = self:ScheduleTimer(funcName, timerTime)
	
	if dbc.debugadmin then
		self:Print("|cff5555ffDEBUG:|r |cff55ff55TIMERSTART|r - ti: "..timerName..", fu: "..funcName..", ha: "..self.ScheduleTimers[timerName])
	end		
end

function GigaItemAuction:GIATimerStop(timerName)
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	local handleCall	
	handleCall = self:CancelTimer(self.ScheduleTimers[timerName], true)

	if dbc.debugadmin and handleCall then
		self:Print("|cff5555ffDEBUG:|r |cffff5555TIMERSTOP|r - ti: "..timerName..", ha: "..(self.ScheduleTimers[timerName] or "no")..", ohc: "..(handleCall and "yes" or "no"))
	end	
	
	self.ScheduleTimers[timerName] = false
	
	if dbc.debugadmin and not handleCall then
		self:Print("|cff5555ffDEBUG:|r |cffff5555TIMERSTOP|r - ti: ["..timerName.."] no found.")
	end
end


---------------------------------------
--~ Auction steuerung
---------------------------------------
function GigaItemAuction:PauseStartAuction(author,start)
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
--~ 	Check, ob der Sender die Berechtigung hat eine Action zu starten
	if not self:CheckPriority(author) then 
		if PLAYERNAME == author then
			self:Print(L["secutity5"])
		end
		return 
	end
	
	if start then
		self.auctionStatusPAUSE = false
		self:StopStatusbar()
		
		if self.auctionStatusBIDDING then
			self:AbfrageObJetztAktion(author)
			
			if self.AUCTIONFrame:IsVisible() then
				self:StartStatusBar()
				self:SetStatusbarText(L["statusbar_text_start"])
				
				if dbc.playsound.pausestart then
					PlaySound("AuctionWindowOpen")
				end
			end
		end
			
		if author == PLAYERNAME then
			self:GIATimerStart("StopAdminAuction","StopAdminAuction", dba.bidTime + 1)
		end
		self:GIATimerStart("StopAuctionButtons","SetAllButtonDisable", dba.bidTime)
		
		if dbn.last.BidName == PLAYERGUID then
			self:SetBreakButtonEnable()
			self:SetButtonDisable()
		else
			self:SetBreakButtonDisable()
			self:SetButtonEnable()
		end
		
		self.ADMINFrame.pauseButton:Enable()
		self.ADMINFrame.aLongButton:Enable()
		self.ADMINFrame.startButton:Disable()
		
	else
		self.auctionStatusPAUSE = true
		self:GIATimerStop("StopAdminAuction")
		self:GIATimerStop("StopAuctionButtons")
		self:GIATimerStop("SetButtonEnable")
		self:PauseStatusbar()
		self:SetAllButtonDisable()
		
		self.ADMINFrame.pauseButton:Disable()
		self.ADMINFrame.aLongButton:Disable()
		self.ADMINFrame.startButton:Enable()
		
		if dbc.showAuctionWindow then
			self:SetStatusbarText(L["statusbar_text_pause"])
			
			if dbc.playsound.pause and self.auctionStatusBIDDING then
				PlaySound("igQuestFailed") 
			end
		end
		
	end		
end

function GigaItemAuction:StopAdminAuction()
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	local cache = dbn.cache
	local winnerName = false
	local winnerItemID, winnerPoint, winnerArt, winnerU80, winnerAchiev
	
	self:GIATimerStop("StopAdminAuction")
	self:GIATimerStop("StopAuctionButtons")
	
	if #cache > 0 then
--~ 		letzen bieter ermitteln
		table_sort(cache,	function(w1,w2)
								if w1.BidTime > w2.BidTime then
									return true
								end
							end)
		
		for i, p in pairs(cache) do
			if p.BidMethod == "G" then
				winnerName 		= cache[i].BidName
				winnerItemID	= dbn.itemID
				winnerPoint 	= cache[i].BidPoint
				winnerArt 		= cache[i].BidArt
				winnerU80 		= cache[i].BidU80
				winnerAchiev	= true
				break
			end
		end
	end
	if not winnerName then
		winnerName 		= false
		winnerItemID	= dbn.itemID
		winnerPoint 	= 0
		winnerArt 		= "M"
		winnerU80 		= false
		winnerAchiev	= false
	end
	if dbc.debugadmin then
		self:Print("|cff5555ffDEBUG:|r SEND - Auction end. Winner: "..(winnerName or "undefine")..", Bids count: "..(#cache or "undefine"))
	end
	self.auctionStatusSTART = false
	self.auctionStatusSONDERBID = false
	self.auctionStatusPAUSE = false
	self.auctionStatusBIDDING = false

	self:SendAddonMSG(self:Serialize(self.amsg.key.sendendauction, winnerName, winnerItemID, winnerPoint, winnerArt, winnerU80, winnerAchiev))
end

function GigaItemAuction:StopAuction(value)
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	local cclass, ccolor, winnerName, winnerItemID, winnerPoint, winnerArt, winnerU80, itemLink
	local winnerAchiev = false
		
	self:GIATimerStop("StopAdminAuction")
	self:GIATimerStop("StopAuctionButtons")
	self:GIATimerStop("SetButtonEnable")
	
	self:StopStatusbar()
	self:HideAUCTIONFrame()
	
	self.auctionStatusSTART = false
	self.auctionStatusSONDERBID = false
	self.auctionStatusPAUSE = false
	self.auctionStatusBIDDING = false
	
	if self.auctionAdminBreak then
		_, cclass = self:GetGuildPlayer(self.auctionAdminBreak)
		ccolor = self:GetClassHexColor(cclass)
		
		self:Print(L["auctionBreak"]:format("|cff"..ccolor..self.auctionAdminBreak.."|r"))
		
		if dbc.playsound.errormsg then
			PlaySound("igQuestFailed") 
		end
	else
--~ 		Daten auswerten
		_, _, winnerName, winnerItemID, winnerPoint, winnerArt, winnerU80, winnerAchiev = self:Deserialize(value)
		_, itemLink = GetItemInfo(winnerItemID)
			
		if dbc.debugadmin then
			self:Print("|cff5555ffDEBUG:|r STOPDATA - pl:"..
				(winnerName or "undefine")..", il:"..
				(itemLink or "undefine")..", po:"..
				(winnerPoint or "undefine")..", p8:"..
				(winnerU80 and "yes" or "no")..", ac:"..
				(winnerAchiev and "yes" or "no")..", wa:"..
				(winnerArt or "undefine"))
		end
		
--~ 		Meldung ausgabe
		if winnerAchiev then
			local nowBidArt = " |cff555555("..self.BidArt.kula[winnerArt]..(winnerU80 and (" |cffff5555"..self.BidArt.lang[4].."|r|cff555555") or "")..")|r"
			
			_, cclass = self:GetGuildPlayer(winnerName)
			ccolor = self:GetClassHexColor(cclass)
	--~             item post
			self:Print(L["auctionTrue"]:format(ccolor, winnerName, itemLink, winnerPoint, nowBidArt))
			
			if dbc.playsound.auctionend then
				PlaySound("igQuestListComplete") 
			end
		else
			self:Print(L["auctionNoBid"]:format(dbn.itemLink))
			if dbc.playsound.auctionend then
				PlaySound("igQuestFailed") 
			end
		end
		
--~ 		Datenbank eintrag
		while #db.auctionCache > 9 do			
			table_sort(db.auctionCache,	function(w1,w2)
									if w1.BidTime < w2.BidTime then
										return true
									end
								end)
			table_remove(db.auctionCache, 1)
		end
		
		table_insert(db.auctionCache, 
			{
				BidName 	= winnerName and winnerName or L["nobody"],
				BidItem 	= itemLink,
				BidPoint 	= winnerPoint, 
				BidTime 	= getGameTimeAsUnix(), 
				BidArt 		= winnerArt, 
				BidU80 		= winnerU80,
				BidAchiev 	= winnerAchiev,
			}
		)
	end
		
	self.auctionAdminBreak = false
	selfBid = false

	self:StopAdmin()
	
	self:ClearNowAuction()
	
	self:GIAFuBarChangeState()
end

---------------------------------------
-- SendAuction
---------------------------------------
function GigaItemAuction:SendBidpoint(bidPoint)
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	
	local sendAttbibut = nil
	
	if dbn.itemID and dbn.itemID ~= "" and tonumber(dbn.itemID) > 0 and dbn.auctionAuthor ~= "" then
		self:Print(L["BID"].." - |cff72ff00"..bidPoint.."|r DKP [|cff72ff00".. self.BidArt.kula[dbc.bidArt]..(dbc.bidU80 and ("|r |cffff5555(u"..dba.bidUP..")") or "").."|r]")
		
		if dbc.debugadmin then
			self:Print("SEND - BID: po:"..bidPoint..", id:"..dbn.itemID..", ba:"..dbc.bidArt..", b8:"..(dbc.bidU80 and "yes" or "no"))
		end
		
		sendAttbibut = self:Serialize(self.amsg.key.bidpoint, bidPoint, dbn.itemID, dbc.bidArt, dbc.bidU80, PLAYERGUID)
		self:SendAddonMSG(sendAttbibut, "WHISPER", dbn.auctionAuthor)
	else
		self:Print(L["hinweis3"])
	end

	self:GIATimerStart("SetButtonEnable","SetButtonEnable", 1)
end

function GigaItemAuction:SendPassLastBid()
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin

	if dbn.itemID and dbn.itemID ~= "" and tonumber(dbn.itemID) > 0 and dbn.auctionAuthor ~= "" then
		self:SendAddonMSG(self:Serialize(self.amsg.key.sendpassbid, PLAYERGUID), "WHISPER", dbn.auctionAuthor)
	else
		self:Print(L["hinweis3"])
	end
end

---------------------------------------
-- ClearNowAuction Database
---------------------------------------
function GigaItemAuction:ClearNowAuction()
	for k in pairs(db.nowAuction.cache) do
		db.nowAuction.cache[k] = nil
	end
	
	db.nowAuction.last = nil
	db.nowAuction = nil
	db.nowAuction = {}
	db.nowAuction.last = {}
	db.nowAuction = {
		itemID = 0,
		itemLink = "",
		auctionAuthor = "",
		channel = "",
		last = {
			BidName = "",
			BidPoint = 0,
			BidTime = 0,
			BidArt = "X",
			BidU80 = false
		},
		cache = nil,
	}
	db.nowAuction.cache = {}
end
---------------------------------------
-- Auction Stats/Colors/Buttons
---------------------------------------
function GigaItemAuction:SetAuctionStats()
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	local cache = dbn.cache
	local currentName = L["nobody"]
	
	local nowBidPoint = dbn.last.BidPoint or 0
	local nowBidArt = nowBidPoint > 0 and (" |cff888888("..dbn.last.BidArt..(dbn.last.BidU80 and (" |cffff1111"..self.BidArt.kurz[4].."|r|cff888888") or "")..")|r") or ""
	self.AUCTIONFrame.AktuellerPreis:SetText(nowBidPoint..nowBidArt)
	
	self:SetAuctionBidStats()	
	
	if dbn.last.BidName ~= "" then
		if dbn.last.BidName == PLAYERGUID then
			currentName = PLAYERNAME
		elseif dbn.auctionAuthor == PLAYERNAME and not selfBid then
			if #cache > 0 then
--~ 		letzen bieter ermitteln
				table_sort(cache,	function(w1,w2)
										if w1.BidTime > w2.BidTime then
											return true
										end
									end)
				
				for i, p in pairs(cache) do
					if p.BidMethod == "G" then
						currentName = p.BidName
						break
					end
				end
			else
				currentName = L["nobody"]
			end
		else
			currentName = L["anonym"]
		end
	else
		currentName = L["nobody"]
	end
	self.AUCTIONFrame.Bieter:SetText(currentName)
end

function GigaItemAuction:SetAuctionBidStats()
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	
	local bidStep1, bidStep2, bidStep3, bidStep4 = dbc.bidStep.step1, dbc.bidStep.step2, dbc.bidStep.step3, dbc.bidStep.step4
	local nowBidPoint = (dbn.last.BidPoint or 0)
	local priorityArt, pointArt
	local playerBidU80 	= self.BidPriority[dbc.bidArt..(dbc.bidU80 and "U" or "")]
	local auctionBidU80 = self.BidPriority[dbn.last.BidArt..(dbn.last.BidU80 and "U" or "")]
	local stufenArt = {
		["hoeher"] = 3,
		["gleich"] = 2,
		["kleiner"] = 1,
	}
	
	if dbc.debugadmin then
		self:Print("|cff5555ffDEBUG:|r SET - SetAuctionBidStats() - playerBidU80:  " .. (playerBidU80 and playerBidU80 or "nil")..", auctionBidU80:  " .. (auctionBidU80 and auctionBidU80 or "nil"))
	end
	
	if playerBidU80 < auctionBidU80 then
		priorityArt = stufenArt["hoeher"]
	elseif playerBidU80 == auctionBidU80 then
		priorityArt = stufenArt["gleich"]
	elseif playerBidU80 > auctionBidU80 then
		priorityArt = stufenArt["kleiner"]
	end
		
	
	if not self.auctionStatusPAUSE and self.auctionStatusSTART then
		if priorityArt >= stufenArt["gleich"] then
			self:SetButtonEnable()
		elseif priorityArt == stufenArt["kleiner"] then
			self:SetButtonDisable()
			self:GIATimerStop("SetButtonEnable")
		end
		
		if dbn.last.BidName ~= "" and dbn.last.BidName == PLAYERGUID then
			self:SetBreakButtonEnable()
		else
			self:SetBreakButtonDisable()
		end
	else
		self:SetAllButtonDisable()
		self:GIATimerStop("SetButtonEnable")
	end
	
	if priorityArt == stufenArt["hoeher"] then
		bidStep1 = dbc.bidStep.step1
		bidStep2 = dbc.bidStep.step2
		bidStep3 = dbc.bidStep.step3
		bidStep4 = dbc.bidStep.step4
	elseif priorityArt <= stufenArt["gleich"] then
		bidStep1 = dbc.bidStep.step1 + nowBidPoint
		bidStep2 = dbc.bidStep.step2 + nowBidPoint
		bidStep3 = dbc.bidStep.step3 + nowBidPoint
		bidStep4 = dbc.bidStep.step4 + nowBidPoint
	end
	
	self.AUCTIONFrame.Bid1Text:SetText(bidStep1)
	self.AUCTIONFrame.Bid2Text:SetText(bidStep2)
	self.AUCTIONFrame.Bid3Text:SetText(bidStep3)
	self.AUCTIONFrame.Bid4Text:SetText(bidStep4)

end

function GigaItemAuction:SetAuctionColors()
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	
	if dbn.last.BidName ~= "" then
		if dbn.last.BidName == PLAYERGUID then
			self.AUCTIONFrame.Bieter:SetTextColor(unpack(self.colors.green))	
			self.AUCTIONFrame.AktuellerPreis:SetTextColor(unpack(self.colors.green))
		elseif not selfBid then
			self.AUCTIONFrame.Bieter:SetTextColor(unpack(self.colors.yellow))	
			self.AUCTIONFrame.AktuellerPreis:SetTextColor(unpack(self.colors.yellow))
		else
			self.AUCTIONFrame.Bieter:SetTextColor(unpack(self.colors.red))	
			self.AUCTIONFrame.AktuellerPreis:SetTextColor(unpack(self.colors.red))		
		end
	else
		self.AUCTIONFrame.Bieter:SetTextColor(unpack(self.colors.neutral))	
		self.AUCTIONFrame.AktuellerPreis:SetTextColor(unpack(self.colors.neutral))
	end
end


---------------------------------------
--~ VERSIONS CHECK
---------------------------------------
function GigaItemAuction:VersionChecks()
	local channel, msg = nil, nil
	if UnitInRaid("player") then
		channel = "RAID"
		msg = L["VersionCheckTextRaid"]
	elseif IsInGuild() then
		channel = "GUILD"
		msg = L["VersionCheckTextGuild"]
	else
		return
	end
	self:SendAddonMSG(self:Serialize(self.amsg.key.sendversioncheck, self.revision), channel)
	self:CancelTimer(self.ScheduleTimers.VersionCheckEnd, true)
	self.ScheduleTimers.VersionCheckEnd = self:ScheduleTimer("VersionCheckEnd", 10)
	self:Print(msg.."...")
end

function GigaItemAuction:VersionShowAll(value)
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	local color, color2
	local _, _, ver, class, player, admin, bidTime = self:Deserialize(value)
	
	ver 			= tonumber(ver)
	bidTime 		= tonumber(bidTime)
	
	if ver < self.revision then
		color = "|cffff6e6e"
	elseif ver > self.revision then
		color = "|cff72ff00"
	else
		color = "|cffffffff"
	end
	
	if bidTime == dba.bidTime then
		color2 = "|cffffffff"
	else
		color2 = "|cffff6e6e"
	end
	
	if not waitForVersionIncomig then		
		for k in pairs(versionList) do
			versionList[k] = nil
		end
		versionList = nil
		versionList = {}
		waitForVersionIncomig = true
	end
	
	if not versionList[ver] then
		versionList[ver] = {}
	end
	table_insert(versionList[ver], {
					["player"] = player,
					["class"] = class,
					["admin"] = admin,
					["bidTime"] = bidTime
	})
	
	self:Print("|cff"..self:GetClassHexColor(class)..""..player.."|r: r"..color..ver.."|r"..(admin and " |cff55ff55(Admin)|r" or "").."  ["..color2..bidTime.."|rsec.]")
end

function GigaItemAuction:VersionCheckEnd()
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	local oldPlayersList = {}
	local playersList = ''
	local versionCount = {
		new = 0,
		old = 0,
		same = 0,
	}

	for ver, players in pairs(versionList) do
		if ver < self.revision then
			versionCount.old = versionCount.old + #players
			playersList = '-- |cffff5555r'..ver..':|r '
			for i, v in pairs(players) do
				playersList = playersList .. "|cff"..self:GetClassHexColor(v.class)..""..v.player.."|r, "
			end
			table_insert(oldPlayersList, playersList)
		elseif ver > self.revision then
			versionCount.new = versionCount.new + #players
		else
			versionCount.same = versionCount.same + #players			
		end
	end
		
	local online, channel = false, false
	local playersOnline = 0
	
	if UnitInRaid("player") then
		local raidNum = GetNumRaidMembers()
		if raidNum > 0 then
			for i=1, raidNum do 
				_, _, _, _, _, _, _, online = GetRaidRosterInfo(i);
				if online then
					playersOnline = playersOnline + 1
				end
			end
		end
		channel = L["RAID"]
	elseif IsInGuild() then
		local numGuildMembers = GetNumGuildMembers(true)
		for i = 1, numGuildMembers, 1 do
			_, _, _, _, _, _, _, _, online = GetGuildRosterInfo(i)
			if online then
				playersOnline = playersOnline + 1
			end
		end
		channel = L["GUILD"]
	end
	
	if not channel then return end
	
	local gesamtVersion = versionCount.old + versionCount.new + versionCount.same
	if gesamtVersion > 0 then
		self:Print(L["version_header"]:format(channel, gesamtVersion, playersOnline))
	end
	if versionCount.new > 0 then
		self:Print(L["version_new"]:format(versionCount.new))
	end
	if versionCount.same > 0 then
		self:Print(L["version_same"]:format(versionCount.same-1))
	end
	if versionCount.old > 0 then
		table_insert(oldvermsg, playersList)
		self:Print(L["version_old"]:format(versionCount.old, playersList))
		if #oldPlayersList > 0 then
			for i, v in pairs(oldPlayersList) do
				self:Print(v)
			end
		end
	end
	
	waitForVersionIncomig = false
end





---------------------------------------
--~ GetGuildPlayer
---------------------------------------
function GigaItemAuction:GetGuildPlayer(player)
	if IsInGuild() and player then
		local numGuildMembers = GetNumGuildMembers(true)
		for i = 1, numGuildMembers, 1 do
			name, rank, _, _, _, _, _, _, _, _, classconst = GetGuildRosterInfo(i)
			if name and string.lower(name) == string.lower(player) then
				return name, classconst, rank
			end
		end
	end
	return L["unknown"], L["unknown"], L["unknown"]
end

---------------------------------------
--~ Colors
---------------------------------------
local default_class_color = {
	r = 1,
	g = 0,
	b = 0,
	a = 0.6
}
function GetClassColor(class)
	if class then
		class = string.upper(class)
		if RAID_CLASS_COLORS and RAID_CLASS_COLORS[class] then
			return RAID_CLASS_COLORS[class].r, RAID_CLASS_COLORS[class].g, RAID_CLASS_COLORS[class].b
		end
	end
	return default_class_color.r, default_class_color.g, default_class_color.b
end

function GigaItemAuction:GetClassHexColor(class)
	local r, g, b = GetClassColor(class)
	return string.format("%02x%02x%02x", r * 255, g * 255, b * 255)
end

function GigaItemAuction:GetColoredName(author, class)
	local cplayer, cclass, cauthor
	if not author then return "|cffff0000"..L["noboby"].."|r" end
	if IsInGuild() then
		if not class then
			cplayer, cclass = self:GetGuildPlayer(author)
		else
			cplayer, cclass = author, class
		end
		
		if cplayer and cplayer ~= L["unknown"] then
			cauthor = "|cff" .. self:GetClassHexColor(cclass) .. cplayer .. "|r"
		else
			cauthor = author
		end
	else
		cauthor = author
	end
	return cauthor
end

---------------------------------------
-- FUBAR OPTIONS
---------------------------------------
local function GetFuBarMinimapAttachedStatus(info)
	return GigaItemAuction:IsFuBarMinimapAttached() or db.FuBar.HideMinimapButton
end

function GigaItemAuction:GIAFuBarOnInitialize()
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	
	if LDB and not IsAddOnLoaded("Broker2FuBar") and not IsAddOnLoaded("FuBar") then
		GIALauncher = LDB:NewDataObject("GigaItemAuction", {
			type = "launcher",
			icon = "Interface\\AddOns\\GigaItemAuction\\Icons\\SyncON",
			OnClick = function(clickedframe, button)
				if IsShiftKeyDown() then GigaItemAuction:ShowConfig() else GigaItemAuction:ToggleAUCTIONFrame() end
			end,
			OnTooltipShow = function(tt)
				tt:AddLine("GigaItemAuction")
				tt:AddLine(L["hint"])
			end,
		})
		if LDBIcon and not IsAddOnLoaded("Broker2FuBar") and not IsAddOnLoaded("FuBar") then
			LDBIcon:Register("GigaItemAuction", GIALauncher, db.MinimapIcon)
		end
	end

	-- Optional launcher support for LFBP-3.0 if present, this code is placed here so
	-- that it runs after all other addons have loaded since we don't embed LFBP-3.0
	-- Yes, this is one big hack since LFBP-3.0 is a Rock library, and we embed it
	-- via Ace3. OnEmbedInitialize() needs to be called manually.
	if LibStub:GetLibrary("LibFuBarPlugin-3.0", true) and not IsAddOnLoaded("FuBar2Broker") and IsAddOnLoaded("FuBar") then
		local LFBP = LibStub:GetLibrary("LibFuBarPlugin-3.0")
		LibStub("AceAddon-3.0"):EmbedLibrary(self, "LibFuBarPlugin-3.0")
		self:SetFuBarOption("tooltipType", "Tablet-2.0")
		self:SetFuBarOption("hasNoColor", true)
		self:SetFuBarOption("cannotDetachTooltip", true)
		self:SetFuBarOption("hideWithoutStandby", true)
		self:SetFuBarOption("iconPath", [[Interface\AddOns\GigaItemAuction\Icons\SyncON]])
		self:SetFuBarOption("hasIcon", true)
		self:SetFuBarOption("defaultPosition", "LEFT")
		self:SetFuBarOption("tooltipHiddenWhenEmpty", true)
		self:SetFuBarOption("clickableTooltip", true)
		self:SetFuBarOption("configType", "None")
		LFBP:OnEmbedInitialize(self)
		function GigaItemAuction:OnUpdateFuBarTooltip()
			GigaItemAuction:GIAFuBarTooltipUpdate()
		end
		function GigaItemAuction:OnFuBarClick(button)
			if IsShiftKeyDown() then GigaItemAuction:ShowConfig() else GigaItemAuction:ToggleAUCTIONFrame() end			
		end
		function GigaItemAuction:OnFuBarUpdateText()
			self:SetFuBarText("GigaItemAuction")
		end
		self.optionsFrames.FuBar = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("GigaItemAuction", L["FuBar Options"], "GigaItemAuction", "FuBar")
		self:UpdateFuBarSettings()
	end
end

function GigaItemAuction:GIAFuBarTooltipUpdate()
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	local auctions = db.auctionCache
	local player, class
	local nowBidArt, nowBidPoint
	
	
--~		------------------------------------------
--~		AuctionItem Lines
	if auctions and #auctions > 0 then
		table_sort(auctions,	function(w1,w2)
									if w1.BidTime > w2.BidTime then
										return true
									end
								end)
		local category_auctionlist = {
			'columns', 4,
			'showWithoutChildren', true,
			'text', "Name",
			'child_textR', 1,
			'child_textG', 1,
			'child_textB', 1,
			'text2', "Item",
			'child_text2R', 1,
			'child_text2G', 1,
			'child_text2B', 6/16,
			'text3', "Datum",
			'child_text3R', 1,
			'child_text3G', 1,
			'child_text3B', 6/16,
			'text4', "DKP",
			'child_text4R', 1,
			'child_text4G', 1,
			'child_text4B', 1,
		}
		local apl = false
		local auctioncat = tablet:AddCategory(unpack(category_auctionlist))
		for i, v in pairs(auctions) do
			tmp = {}
			if v.BidName ~= L['nobody'] then
				_, class = self:GetGuildPlayer(v.BidName)
			else
				class = L['unknown']
			end
--~             name
			table_insert(tmp, 'text')
			table_insert(tmp, "|cff"..self:GetClassHexColor(class)..v.BidName.."|r")
			
--~             item
			table_insert(tmp, 'text2')
			table_insert(tmp, v.BidItem)
			
--~             datum
			table_insert(tmp, 'text3')
			table_insert(tmp, getCurrentMiniDate(v.BidTime))
			
--~             DKP
			if v.BidAchiev then
				nowBidPoint = v.BidPoint
				nowBidArt = " |cff888888("..self.BidArt.kula[v.BidArt]
				nowBidArt = nowBidArt .. (v.BidU80 and (" |cffff5555"..self.BidArt.lang[4].."|r|cff888888") or "")..")|r"
			else
				nowBidPoint = "-"
				nowBidArt = ""
			end
			table_insert(tmp, 'text4')
			table_insert(tmp, (nowBidPoint..nowBidArt))
			
--~             funktion
			table_insert(tmp, 'func')
			table_insert(tmp, 'GIAFuBarOnItemClick')
			table_insert(tmp, 'arg1')
			table_insert(tmp, self)
			table_insert(tmp, 'arg2')
			table_insert(tmp, i)
			
--~             hacken
			if v.BidName == PLAYERNAME then
				apl = true
			else
				apl = false
			end
			table_insert(tmp,'hasCheck')
			table_insert(tmp, true)
			table_insert(tmp,'checked')
			table_insert(tmp, apl)
	
			auctioncat:AddLine("arg1", i, unpack(tmp))
		end
	end
	local category_optionen = {
		'columns', 1,
		'showWithoutChildren', true,
		'text', "Optionen",
		'child_textR', 1,
		'child_textG', 1,
		'child_textB', 1,
	}
	local cat = tablet:AddCategory(unpack(category_optionen))
	cat:AddLine()
	cat:AddLine('text', L["VersionCheckText"], 'func', function() GigaItemAuction:VersionChecks() end, 				'textR', 1, 'textG', 1, 'textB', 0)
	cat:AddLine('text', L["Open the configuration dialog"], 'func', function() GigaItemAuction:ShowConfig() end, 	'textR', 1, 'textG', 1, 'textB', 0)
	cat:AddLine('text', L["Toggle GIA"], 'func', function() GigaItemAuction:ToggleAUCTIONFrame() end, 				'textR', 1, 'textG', 1, 'textB', 0)
	if self:CheckPriority(PLAYERNAME) then
		cat:AddLine('text', L["Admin GIA"], 'func', function() GigaItemAuction:ShowADMINFrame() end, 				'textR', 1, 'textG', 1, 'textB', 0)
	end
	tablet:SetHint(self.hint)
end

function GigaItemAuction:GIAFuBarOnItemClick(itemId)
	if not itemId then return end
	if IsShiftKeyDown() then
		table_remove(GigaItemAuction.db.profile.auctionCache, itemId)
	end
end

function GigaItemAuction:GIAFuBarChangeState()
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	if LibStub:GetLibrary("LibFuBarPlugin-3.0", true) and IsAddOnLoaded("FuBar") then 
		local LFBP = LibStub:GetLibrary("LibFuBarPlugin-3.0")
		LibStub("AceAddon-3.0"):EmbedLibrary(self, "LibFuBarPlugin-3.0")
		if self:IsEnabled() then
			if dbn.itemLink ~= "" then
				self:SetFuBarOption("iconPath", "Interface\\AddOns\\GigaItemAuction\\Icons\\SyncON2")
				self.hint = L["hint"]
			else
				self:SetFuBarOption("iconPath", "Interface\\AddOns\\GigaItemAuction\\Icons\\SyncON")
				self.hint = L["hint"]
			end
		else
			self:SetFuBarOption("iconPath", "Interface\\AddOns\\GigaItemAuction\\Icons\\SyncOFF")
			self.hint = L["disabledhint"]
		end
		LFBP:OnEmbedInitialize(self)
		self:UpdateFuBarSettings()
	end
end

function GigaItemAuction:UpdateFuBarSettings()
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	if LibStub:GetLibrary("LibFuBarPlugin-3.0", true) then
		if db.FuBar.HideMinimapButton then
			self:Hide()
		else
			self:Show()
			if self:IsFuBarMinimapAttached() ~= db.FuBar.AttachMinimap then
				self:ToggleFuBarMinimapAttached()
			end
		end
	end
end


---------------------------------------
-- OPTIONEN
---------------------------------------
function GigaItemAuction:SetupOptions()
	local dbn = db.nowAuction
	local dbc = db.config
	local dba = db.admin
	self.optionsFrames 	= {}
	self.OptionsConfig 	= self:GetOptionsConfig()
	self.OptionsSlash 	= self:GetOptionsSlash()

	-- setup options table
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("GigaItemAuction", self.OptionsConfig)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("GIASlashCommand", self.OptionsSlash, L["Slash-Commands1"])
	LibStub("AceConfig-3.0"):RegisterOptionsTable("GIASlashCommand", self.OptionsSlash, L["Slash-Commands2"])
	local ACD3 = LibStub("AceConfigDialog-3.0")

	-- The ordering here matters, it determines the order in the Blizzard Interface Options
	self.optionsFrames.GigaItemAuction = ACD3:AddToBlizOptions("GigaItemAuction", nil, nil, "General")
	self.optionsFrames.Admin = ACD3:AddToBlizOptions("GigaItemAuction", L["Admin Settings"], "GigaItemAuction", "Admin")
	self.optionsFrames.ItemFilter = ACD3:AddToBlizOptions("GigaItemAuction", L["Filter Settings"], "GigaItemAuction", "ItemFilter")
	
	
	self:RegisterModuleOptions("GIASlashCommand", self.OptionsSlash, L["Slash Command"])
	self:RegisterModuleOptions("Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db), L["Profiles"])

	-- Add ordering data to the option table generated by AceDBOptions-3.0
	self.OptionsConfig.args.Profiles.order = -2
end

function GigaItemAuction:RegisterModuleOptions(name, optionTbl, displayName)
	self.OptionsConfig.args[name] = (type(optionTbl) == "function") and optionTbl() or optionTbl
	self.optionsFrames[name] = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("GigaItemAuction", displayName, "GigaItemAuction", name)
end

function GigaItemAuction:ShowConfig()
	-- Open the profiles tab before, so the menu expands
	InterfaceOptionsFrame_OpenToCategory(self.optionsFrames.Profiles)
	InterfaceOptionsFrame_OpenToCategory(self.optionsFrames.GigaItemAuction)
end